from Util import Set
import WoodiiBiomass


#ATPase = 'ADENOSINETRIPHOSPHATASE-RXN' # to move to BuildLP, which will be imported by woodiiLP

def BuildLP(m):

    lp = m.GetLP()
    lp.SetObjective(m.sm.cnames)
    return lp


def BiomassLP(m):
    """ lp object, constrained to biomass fluxes defined in WoodiiBiomass """

    fd = WoodiiBiomass.FluxDic(m)
    
    biomassMet = Set.Complement(filter(lambda x: x.endswith("_bm_tx"), m.sm.cnames), fd.keys())
    for tx in biomassMet:
        fd[tx]=0    
        
    lp = BuildLP(m)        
    lp.SetFixedFlux(fd)
    
    return lp

def NoBiomassLP(m):
    """ lp object, constrained to biomass fluxes defined in WoodiiBiomass """

    fd = WoodiiBiomass.FluxDic(m)
    
    biomassMet = Set.Complement(filter(lambda x: x.endswith("_bm_tx"), m.sm.cnames), fd.keys())
    for tx in biomassMet:
        fd[tx]=0    
        
    lp = BuildLP(m)        
    lp.SetFixedFlux(fd)

    for r in m.sm.cnames:
        if 'bm_tx' in r:
            lp.SetFluxBounds({r : (-500,0)})
    
    return lp
