from ScrumPy.Bioinf import Biomass
from ScrumPy.Util import Set # on trial for molToGram

import sys
sys.path.append('/home/noah/model/software/ScrumPy_scipy/ScrumPy/Bioinf') #for use on laptop environment

import MolWtsWoodii
Biomass.MolWts.MolWts.update(MolWtsWoodii.MolWts) #allows local updates to MolWts to be made



prot = Biomass.Composition( #aa breakdown from B.subtilis (Sauer 1996)
    0.5285,{
        "CYS" : 0.0122,
        "L-ASPARTATE" : 0.0434,
        "ASN" : 0.0434,
        "GLT" : 0.0650,
        "GLN" : 0.0650,
        "SER" : 0.0427,
        "GLY" : 0.1008,
        "THR" : 0.0487,
        "HIS" : 0.0175,
        "D-ALANINE" : 0.1210,
        "TYR" : 0.0255,
        "ARG" : 0.0403,
        "VAL" : 0.0682,
        "TRP" : 0.0067,
        "MET" : 0.0240,
        "PHE" : 0.0373,
        "ILE" : 0.0587,
        "LEU" : 0.0749,
        "LYS" : 0.0697,
        "PRO" : 0.0357
        }
    )



DNA = Biomass.Composition( # overall % from B.subtilit. breakdown calculated bioinformatically from genome, counting bases
    0.026, {
        "TTP" : 0.30173579408704115,
        'DATP': 0.30488281554211766,
        'DCTP': 0.19320916826811466,
        'DGTP': 0.20017222210272656
        }
    )


# commented out 27/04/18
##RNA = Biomass.Composition( # overall % from B.subtilis.
##    0.0655, {
##        "AMP" : 0.125,
##        "CMP" : 0.125,
##        "GMP" : 0.125,
##        "UMP" : 0.125
##
##        }
##    )


RNA = Biomass.Composition( # overall % from B.subtilis.
    0.0655, {
        "ATP" : 0.25,
        "CTP" : 0.25,
        "GTP" : 0.25,
        "UTP" : 0.25

        }
    )


cwall = Biomass.Composition( # overall % from B.subtilis. Breakdown from lit of awoodii cwall
    0.2546,
	{
        "WoodiiPeptidoglycan" : 0.657, #peptides, UDP-MurNAc, UDP-GluNAc
        "WoodiiTechoic-Acid" : 0.353  #rhamnose,glc,gal,g3p,UDP-GlcNAc,UDP-ManNac
        }
    )


# commented out 27/04/18
##lipid = Biomass.Composition( #from Bacillus megatorium. palmitate as the fatty acid
##    0.076,
##    {
##        "CPD-18361":0.3, #L-1-PHOSPHATIDYL-GLYCEROL (has 2 palmitates)
##       "CPD-18367":0.69, # L-1-PHOSPHATIDYL-ETHANOLAMINE (has 2 palmitates)
##        "CPD-19674" : 0.1 #Cardiolipin (has 4 palmitates)
##        
##        }
##    )


lipid = Biomass.Composition( #from Bacillus megatorium. palmitate as the fatty acid
    0.076,
    {
        "CPD-18361":0.31, #L-1-PHOSPHATIDYL-GLYCEROL (has 2 palmitates)
       "CPD-18367":0.59, # L-1-PHOSPHATIDYL-ETHANOLAMINE (has 2 palmitates)
        "CPD-19674" : 0.1 #Cardiolipin (has 4 palmitates)
        
        }
    )

soluble = Biomass.Composition( #adapted from Soga T et al.(2003)Quantitative metabolome analysis... J.Proteome Res 2:488-494. Vitamin b12 from diversity of corrinoids in acetogens paper (see lab book 9th Feb) need to rethink some of these
    0.0494, {
        "NAD":0.515, 
        "AMP":0.149,
       #"ATP" :0.096, #already in RNA
        "ADP" :0.083,
        "CMP" : 0.033,
        "NADP" : 0.029,
        "CTP": 0.016,
        "GMP": 0.016,
        "CDP": 0.014,
        "GTP": 0.011,
        "NADH": 0.006,
        "GDP" : 0.016, 
       # "THF" :0.048, # cannot be produced
        "CO-A" :0.008, # 0.014 previous
        "FAD"   : 0.006, # 0.010 previous
        "ADENOSYLCOBALAMIN" : 0.010 # 0.026 previous 
        }
    
)


All = Biomass.Composition(
    1.0, 
    {
        "prot" : prot,
        "DNA" : DNA,
        "RNA" : RNA,
        "cwall" : cwall,
        "lipid": lipid,
        "soluble": soluble
    }
)


def FluxDic(m):

        rv = {}
        
        for met in All.GetLeaves():
                xp = Biomass.WhatExports(m,met)
                if xp == None:
                        print(("no tx for ", met))
                else:
                        rv[xp] = -All.MolsOf(met)      
        return rv



